# hey Emacs, its -*- mode: rpm-spec; coding: cyrillic-cp1251; -*-
# $Id: subversion,v 1.10 2003/06/25 06:52:15 svd Exp $
# Subversion

#%%def_enable included_apr
%def_with swig
%def_with doc
%def_with server
%def_with dav

%def_disable check
%def_disable static

%define svn_ver 1.0.6

#%%define apr_ver_major 0
%define apr_ver 0.9.5
#%%define aprpkg_ver %{apr_ver}_svn%svn_ver

%define _python_libdir %_libdir/python2.3/

%define svn_user subversion
%define svn_group subversion
%define svn_repo_dir %_localstatedir/subversion
%define svn_service svnserve

# Directory for subversion-tools
%define _svn_tools_dir %_datadir/%name

Name: subversion	
Version: %svn_ver
Release: alt1

Summary: A version control system
Group: Development/Other
License: Apache
Url: http://subversion.tigris.org/
Packager: Sviatoslav Sviridov <svd@altlinux.ru>

Source: %name-%version.tar.bz2
Source1: subversion.el
Source2: %name-config-1.0.0.tar.bz2
Source3: svnserve.init
Source4: svnserve.sysconfig
Source5: subversion-apache.conf

Patch1: subversion-0.37.0-alt-dockbook.patch

Requires: lib%name = %version-%release

# since 1.0.6 neon 0.24.7 required (fixes wire compression bugs)
Requires: libneon >= 0.24.7

# Automatically added by buildreq on Wed Jun 09 2004
BuildRequires: XFree86-libs XFree86-locales docbook-style-xsl emacs21-common glibc-devel-static libapr-devel libaprutil-devel libe2fs-devel libexpat-devel libgdbm-devel libkrb5-devel libldap-devel libneon-devel libssl-devel perl-devel xpm xsltproc zlib-devel

# Manually removed from list emacs-related packages, libdb4.x-devel (specified below as libdb4.x-devel),
# python-devel (specified below as python-devel = 2.3);
# swig, libswigpy (conditional requirement, needed only for subversion-python)
# apache2-devel (needed only for subversion-server-dav)
BuildPreReq: libdb4.2-devel
BuildPreReq: libneon-devel >= 0.24.7
BuildPreReq: python-devel = 2.3
# libaprutil built with libdb4.2 required
BuildPreReq: libaprutil-devel >= 0.9.5-alt0.3

%package -n lib%name
Summary: Shared libraries required for subversion
Group: System/Libraries
Requires: lib%name = %version-%release
Requires: libapr >= %apr_ver
%if_enabled included_apr
Requires: libaprutil >= %apr_ver
%endif

%package -n lib%name-devel
Summary: Development files for applications which will use subversion libraries
Group: Development/C
Provides: %name-devel = %version-%release
Requires: libapr-devel >= %apr_ver
%if_enabled included_apr
Requires: libaprutil-devel >= %apr_ver
%endif

%package -n lib%name-devel-static
Summary: Static libraries for developing statically linked applications which will use subversion libraries
Group: Development/C
Requires: lib%name-devel = %version-%release

%if_with swig
%package python
Summary: Pyhton bindings for Subversion
Group: Development/Other
Requires: lib%name = %version-%release
BuildPreReq: swig
BuildPreReq: swig-runtime-python
%endif

%package -n emacs-%name
Summary: Subversion support for Emacs
Group: Editors
Requires: %name

%package -n emacs-%name-el
Summary: The Emacs Lisp sources for bytecode included in emacs-%name
Group: Editors

%if_with doc
%package doc
Summary: Subversion documentation
Group: Books/Other
Requires(post,preun): %__install_info
%endif

%if_with server
%package server-common
Summary: Common files required to maintain subversion server
Group: System/Servers
Requires: lib%name = %version-%release

%package server-standalone
Summary: Subversion standalone server
Group: System/Servers
Requires: %name-server-common >= %version-%release

%description server-common
The goal of the Subversion project is to build a revision system that
is a compelling replacement for CVS in the open community. The software
is released under an Apache/BSD-style source license. See the status
page for current progress.
This package contains common files required for maintaing subversion
repositories.

%description server-standalone
This package contains scripts for running standalone subversion server.

%if_with dav
%package server-dav
Summary: Subversion server module for Apache
Group: System/Servers 
BuildPreReq: apache2-devel
Requires: lib%name = %version-%release

%description server-dav
The apache2 server shared module for running subversion server.
%endif

%endif

%package tools
Summary: Tools for subversion
Group: Development/Other
Requires: python
Requires: subversion, subversion-server-common, subversion-python

%description
The goal of the Subversion project is to build a revision system that
is a compelling replacement for CVS in the open community. The software
is released under an Apache/BSD-style source license. See the status
page for current progress.

%description -n lib%name
The goal of the Subversion project is to build a revision system that
is a compelling replacement for CVS in the open community. The software
is released under an Apache/BSD-style source license. See the status
page for current progress.

%description -n lib%name-devel
The goal of the Subversion project is to build a revision system that
is a compelling replacement for CVS in the open community. The software
is released under an Apache/BSD-style source license. See the status
page for current progress.

%description -n lib%name-devel-static
The goal of the Subversion project is to build a revision system that
is a compelling replacement for CVS in the open community. The software
is released under an Apache/BSD-style source license. See the status
page for current progress.

%if_with swig
%description python
This package contains the files necessary to use the subversion library
functions within python scripts.
%endif

%description -n emacs-%name
vc-svn is a VC backend for Subversion.
psvn is an interface for subversion. psvn provides a similar interface
for subversion as pcl-cvs for cvs.

All Emacs Lisp code is byte-compiled, install emacs-%name-el for sources.

%description -n emacs-%name-el
emacs-%name-el contains the Emacs Lisp sources for the bytecode
included in emacs-%name package

%if_with doc
%description doc
This package contains subversion documentation:
- "Version Control with Subversion" book
- Documents for Subversion programmers
- Documents for Subversion users
%endif

%description tools
Tools for Subversion. This package includes:
+ hook scripts
+ bash completion,
+ other useful scripts (hot-backup.py, server-vsn.py, showchange.pl),
+ some scripts and code examples.

%prep
%setup -q
%patch1 -p1

%build
#CONFIGURE_OPTS="--disable-all-static --disable-rpath"
CONFIGURE_OPTS="%{subst_enable static} --disable-rpath"
CONFIGURE_OPTS="$CONFIGURE_OPTS --with-ssl --with-neon=%prefix"
CONFIGURE_OPTS="$CONFIGURE_OPTS --with-apr=%prefix --with-apr-util=%prefix"

%if_with dav
CONFIGURE_OPTS="$CONFIGURE_OPTS --with-apxs=%apache_apxs"
%endif

%configure $CONFIGURE_OPTS
%make_build

%if_with swig
%make_build swig-py
%endif

%if_with doc
# Build subversion documentation
%make XSL_DIR=/usr/share/xml/docbook/xsl-stylesheets \
    doc-all-html doc-all-info
%endifhook-scripts/mailer

%if_enabled check
echo "*** Running regression tests on RA_LOCAL (FILE SYSTEM) layer ***"
%make check
echo "*** Finished regression tests on RA_LOCAL (FILE SYSTEM) layer ***"
%endif

# Building emacs-subversion files
emacs -batch --eval '(byte-compile-file "contrib/client-side/vc-svn.el")'
emacs -batch --eval '(byte-compile-file "contrib/client-side/psvn/psvn.el")'

%install
%make_install DESTDIR=%buildroot install
%__mkdir -p %buildroot%_sysconfdir/%name
%__tar xjf %SOURCE2 -C %buildroot%_sysconfdir/%name

%if_with swig
%make_install DESTDIR=%buildroot install-swig-py
%__install -d %buildroot%_python_libdir/site-packages
%__rm -f %buildroot%_libdir/svn-python/libsvn/*.a %buildroot%_libdir/svn-python/libsvn/*.la
%__mv %buildroot%_libdir/svn-python/libsvn %buildroot%_python_libdir/site-packages
%__rm -rf %buildroot%_libdir/svn-python
%__cp -r %_builddir/%buildsubdir/subversion/bindings/swig/python/svn %buildroot%_python_libdir/site-packages
%endif

# Installing emacs-subversion files
%__mkdir -p %buildroot%_emacslispdir/%name
%__install -m 644 contrib/client-side/vc-svn.el* %buildroot%_emacslispdir/%name
%__install -m 644 contrib/client-side/psvn/psvn.el* %buildroot%_emacslispdir/%name
%__mkdir -p %buildroot%_sysconfdir/emacs/site-start.d
%__install -m 644 %SOURCE1 %buildroot%_sysconfdir/emacs/site-start.d

%if_with doc
# Installing subversion-doc files
%make DESTDIR=%buildroot install-docs
%make XSL_DIR=/usr/share/xml/docbook/xsl-stylesheets \
    INSTALL_DIR=%buildroot%_defaultdocdir/%name-doc-%version/book \
    -C doc/book install-book-html install-misc-html
#%__bzip2 -qc9 doc/book/book/book.ps >%buildroot%_defaultdocdir/%name-doc-%version/book/book.ps.bz2
%__cp doc/book/book/book.pdf %buildroot%_defaultdocdir/%name-doc-%version/book/
%__cp -r doc/README doc/user %buildroot%_defaultdocdir/%name-doc-%version/
%__mkdir -p %buildroot%_defaultdocdir/%name-doc-%version/programmer/design
%__install -m644 doc/programmer/*.txt %buildroot%_defaultdocdir/%name-doc-%version/programmer
%__install -m644 doc/programmer/design/*.html %buildroot%_defaultdocdir/%name-doc-%version/programmer/design
#%__cp -r doc/translations %buildroot%_defaultdocdir/%name-doc-%version/

%__install -m644 doc/programmer/design/*.info* %buildroot%_infodir
%endif

%if_with server
# Installing subversion-server files
%__mkdir_p %buildroot%svn_repo_dir
%__mkdir_p %buildroot%_sysconfdir/rc.d/init.d %buildroot%_sysconfdir/sysconfig
%__install -m 755 %SOURCE3 %buildroot%_sysconfdir/rc.d/init.d/%svn_service
%__install -m 644 %SOURCE4 %buildroot%_sysconfdir/sysconfig/%svn_service

%if_with dav
%__mkdir -p %buildroot%apache_addonconfdir
%__install -m 644 %SOURCE5 %buildroot%apache_addonconfdir/subversion.conf
%endif
%endif

# Installing subversion-tools files
%__mkdir -p %buildroot%_svn_tools_dir/hook-scripts
%__mkdir -p %buildroot%_defaultdocdir/%name-tools-%version/hook-scripts
%__cp -r tools/backup/*.py tools/client-side/* %buildroot%_svn_tools_dir/
%__mv -f %buildroot%_svn_tools_dir/bash_completion_test %buildroot%_defaultdocdir/%name-tools-%version/
%__subst 's:/usr/bin/env python2$:/usr/bin/env python:' tools/hook-scripts/*.py
%__cp tools/hook-scripts/*.pl tools/hook-scripts/*.py tools/hook-scripts/mailer/*.py \
	%buildroot%_svn_tools_dir/hook-scripts/
# commit-access-control.pl has unresolved dependencies
%__mv -f -- %buildroot%_svn_tools_dir/hook-scripts/commit-access-control.pl %buildroot%_defaultdocdir/%name-tools-%version/hook-scripts/
%__cp tools/hook-scripts/README tools/hook-scripts/*.example tools/hook-scripts/mailer/*.example \
	%buildroot%_defaultdocdir/%name-tools-%version/hook-scripts/
%__cp -r tools/examples %buildroot%_defaultdocdir/%name-tools-%version/
#%__cp -r tools/dev %buildroot%_svn_tools_dir/

%post -n lib%name -p /sbin/post_ldconfig
%postun -n lib%name -p /sbin/postun_ldconfig

%if_with doc
%post doc
%install_info svn-design.info

%preun doc
%uninstall_info svn-design.info
%endif

%if_with server
%pre server-common
/usr/sbin/groupadd -r -f %svn_group
/usr/sbin/useradd -r -g %svn_group -d %svn_repo_dir -s /dev/null -c 'Subversion' %svn_user >/dev/null 2>&1 ||:
if [ $1 -gt 1 ]; then
	/usr/sbin/usermod -d %svn_repo_dir %svn_user
fi

%post server-standalone
%post_service %svn_service

%preun server-standalone
%preun_service %svn_service

%if_with dav
%postun server-dav
/sbin/service httpd2 condreload ||:

%endif
%endif

%files
%dir %_sysconfdir/%name
%config(noreplace) %_sysconfdir/%name/config
%config(noreplace) %_sysconfdir/%name/servers
%_sysconfdir/%name/README.txt
%_bindir/svn
%_bindir/svnversion
%_mandir/man1/svn.1.*
%_mandir/man1/svnversion.1.*
%doc BUGS CHANGES COMMITTERS COPYING HACKING INSTALL README

%files -n lib%name
%_libdir/libsvn_*-*.so*

%files -n lib%name-devel
#%_bindir/svn-config
%_libdir/libsvn_*-*.so
#%_libdir/libsvn_*.la
%_includedir/%name-*

%if_enabled static
%files -n lib%name-devel-static
%_libdir/libsvn_*.a
%endif

%if_with swig
%files python
%_python_libdir/site-packages/svn
%_python_libdir/site-packages/libsvn
%endif

%files -n emacs-%name
%_sysconfdir/emacs/site-start.d/*.el
%_emacslispdir/%name/*.elc

%files -n emacs-%name-el
%_emacslispdir/%name/*.el

%if_with doc
%files doc
%_infodir/svn-design*
%doc %_defaultdocdir/%name-doc-%version
%endif

%if_with server
%files server-common
%_bindir/svnserve
%_bindir/svnadmin
%_bindir/svnlook
%_bindir/svndumpfilter
%_mandir/man1/svnadmin.1.*
%_mandir/man1/svnlook.1.*
%_mandir/man1/svndumpfilter.1.*
%_mandir/man5/svnserve.conf.5.*
%_mandir/man8/svnserve.8.*
%defattr(640,%svn_user,%svn_group,2710)
%dir %svn_repo_dir

%files server-standalone
%_sysconfdir/rc.d/init.d/%svn_service
%_sysconfdir/sysconfig/%svn_service

%if_with dav
%files server-dav
%config(noreplace) %apache_addonconfdir/*.conf
%apache_moduledir/*.so
%endif
%endif

%files tools
%dir %_svn_tools_dir
%_svn_tools_dir/*.py
%_svn_tools_dir/*.pl
%_svn_tools_dir/bash_completion
%dir %_svn_tools_dir/hook-scripts
%_svn_tools_dir/hook-scripts/*.py
%_svn_tools_dir/hook-scripts/*.pl
%dir %_defaultdocdir/%name-tools-%version
%dir %_defaultdocdir/%name-tools-%version/examples
%_defaultdocdir/%name-tools-%version/bash_completion_test
%_defaultdocdir/%name-tools-%version/hook-scripts
%_defaultdocdir/%name-tools-%version/examples/*.py
%_defaultdocdir/%name-tools-%version/examples/*.c

%changelog
* Wed Aug 04 2004 Sviatoslav Sviridov <svd@altlinux.ru> 1.0.6-alt1
- 1.0.6: security fix in mod_authz_svn
- requires neon >= 0.24.7 (fixes wire compression bugs)

* Fri Jun 11 2004 Sviatoslav Sviridov <svd@altlinux.ru> 1.0.5-alt1
- 1.0.5: fixed subversion svn:// protocol string parsing error
  (CAN-2004-0413)
- Added apache2 support
- Changed mode to 2710 for /var/lib/subversion
- Updated BuildRequires
- Do not build static library by default
- Spec cleanup: removed support for cvs2svn package

* Fri May 14 2004 Dmitry V. Levin <ldv@altlinux.org> 1.0.2-alt2
- Fixed subversion sscanf overflow (CAN-2004-0397).

* Wed May 12 2004 ALT QA Team Robot <qa-robot@altlinux.org> 1.0.2-alt1.1
- Rebuilt with openssl-0.9.7d.

* Thu Apr 29 2004 Sviatoslav Sviridov <svd@altlinux.ru> 1.0.2-alt1
- 1.0.2
- updated BuildRequires

* Mon Mar 15 2004 Sviatoslav Sviridov <svd@altlinux.ru> 1.0.1-alt1
- 1.0.1 (bugfix release)
- do not package cvs2svn (moved to its own repository),
  see http://cvs2svn.tigris.org/ for new location

* Mon Feb 23 2004 Sviatoslav Sviridov <svd@altlinux.ru> 1.0.0-alt1
- 1.0.0
- specfile updated:
  + do not package cvs2svn manpage (manpage was not included
    in 1.0.0 release)
  + new subpackage created: subversion-tools

* Fri Feb 20 2004 Sviatoslav Sviridov <svd@altlinux.ru> 0.37.0-alt3
- added new subpackages:
  subversion-server-common, subversion-server-standalone

* Thu Feb 12 2004 Sviatoslav Sviridov <svd@altlinux.ru> 0.37.0-alt2
- rebuild with libdb4.2

* Mon Feb 02 2004 Sviatoslav Sviridov <svd@altlinux.ru> 0.37.0-alt1
- 0.37.0
- conditional build of subversion-doc
- subversion-swig built with python2.3

* Sat Oct 25 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.32.1-alt1
- 0.32.1

* Tue May 20 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.23.0-alt1
- 0.23.0
- removed svn-config from libsubversion-devel

* Wed May 14 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.22.2-alt1
- 0.22.2

* Mon May 12 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.22.1-alt1
- 0.22.1
- added config dir /etc/subversion with config examples
- added the new 'svndumpfilter' program

* Wed Apr 23 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.21.0-alt1
- 0.21.0
- fixed group of package cvs2svn

* Fri Apr 04 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.20.1-alt1
- added documentation to cvs2svn package
- added package subversion-doc
- svn-design.info* moved to subversion-doc
- added package emacs-subversion

* Tue Mar 18 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.19.1-alt0.1
- 0.19.1
- building python bindings
- building cvs2svn package

* Tue Mar 11 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.19-alt1
- 0.19

* Sun Feb 23 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.18-alt1
- 0.18
- Added missing headers to libapr-subversion devel and
  libaprutil-subversion-devel

* Thu Jan 30 2003 Sviatoslav Sviridov <svd@altlinux.ru> 0.17.1-alt1
- first build for ALT Linux
